var express = require('express');
var router = express.Router();
var rp = require('request-promise');

router.post('/', function(req, res, next) {
    var uri = req.body.uri;
    var data = req.body.data;
    var method = req.body.method;
    var contentType = req.body.contentType;
    var headers = req.headers;
    rp({
        uri: uri,
        body: JSON.stringify(data),
        method: method,
        resolveWithFullResponse: true,
        headers: {
            'Authorization': 'Basic ' + new Buffer(headers.username + ':' + headers.password).toString("base64"),
            'Content-Type': contentType,
            'Accept': 'application/json'
        },
        transform: function (body, response) {
            return JSON.parse(body);
        }
    }).then(function(result){
        res.json(result);
    }).catch(function(reason){
        res.status(reason.statusCode || 500).send(reason.message);
    });

});

module.exports = router;